﻿class Gallery {
	// SETTINGS
	private var cols:Number = 5;
	private var xSpacing:Number = 3;
	private var ySpacing:Number = 5;
	
	// VARS
	private var _host:MovieClip;
	private var xmlDocument:String = "portfolio.xml";
	private var imageViewer:ImageViewer;
	private var numberHolder:MovieClip;
	private var imageDatabase:Array;
	
	// CONSTRUCTOR
	// Denna funktion, constructorn, körs automatiskt då instancen av klassen skapas
	// Den skapas på Actions layern i gallery.fla
	function Gallery(hostMovieClip:MovieClip) {
		
		// Vi sparar in referensen till stagen som vi fått in så att vi kan använda den senare
		_host = hostMovieClip;
		
		// Vi skapar en XmlLoader för att ladda & leka med XML filen
		var xmlLoader:XmlLoader = new XmlLoader(this);
		
		// Vi säger att den skall ladda filen ..
		xmlLoader.load(xmlDocument);
		
		// För att kunna se på bilderna gör vi en instans av vår ImageViewer klass.
		imageViewer = new ImageViewer(_host);
		
		// Då vi får resultet från XML laddaren tillbaka, vill vi placera knapparna nånstans. Vi gör ett tomt movieclip
		numberHolder = hostMovieClip.createEmptyMovieClip("numberHolder", hostMovieClip.getNextHighestDepth());
		
		// Vi vill ha numberHolder på rätt ställe så vi lägger dit den
		numberHolder._x = 302; // 2px till för att kompensera för titel texten ..
		numberHolder._y = 55;
	}
	
	// PRIVATE
	
	// PUBLIC
	// Kallas från XmlLoader då xml't är laddat, parsat och lagt i arrays
	// Funktionen kan köras externt för att den är public.
	public function initialize(copyTexts:Array, imageData:Array):Void {
		// Vi lägger copy textena från XML in i text boxarna
		_host.title1.text = copyTexts[0];
		_host.title2.text = copyTexts[1];
		_host.description.text = copyTexts[2];
		
		// Vi måste spara imageData arrayn för senare användning
		imageDatabase = imageData;
		
		// Vi vill skapa länkar, så vi skapar massor med movieclips, med en loop. Piece of cake!
		// Vi måste först skapa två variabler för att hålla koll på kolumner och rader. De skalla vara 0 från början, så att vi kan använda ++ senare..
		var colIndex:Number = 0;
		var rowIndex:Number = 0;
		// For loop för att .. loopa ?
		for (var i:Number = 0; i < imageData.length; i++) {			
			// Vi har redan skapat en numberHolder, så vi lägger knapparna in i den. Kolla F1 på attachMovie!
			var button:MovieClip = numberHolder.attachMovie("numberBut", "button_" + i, numberHolder.getNextHighestDepth());
			
			// Om index är under 10, lägg till en 0'a före (snyggare).
			// Vi lägger även 1 till till i, så att vi börjar från 1, inte 0 (snyggare)
			if (i < 10) {
				button.title.text = "0" + (i+1);
			} else {
				button.title.text = i+1;
			}
			
			// Kolla om colindex är samma som cols, eller mera
			if (colIndex > cols) {
				// En ny rad krävs, nolla även colIndex (vi skall ju tillbaka till första kolumnen)
				rowIndex++;
				colIndex = 0;
			}
			
			// Alltid bra att ha index i knappen. Här krävs den dessutom, för att vi skall veta vilken knapp som blivit tryckt!
			button.id = i;
			
			button._x = colIndex * button._width + colIndex * xSpacing;
			button._y = rowIndex * button._height + rowIndex * ySpacing;
			
			// Vi har fått en ny kolumn, lägg till en till colIndex!
			colIndex++;
			
			// Lite "fulkod" för att komma snabbt undan, borde egentligen göra en klass för knappen (!!!)
			// Nja det får gå, klockan är 1:20. För att kunna kalla på funktioner i denna klass från movieclippet, måste vi spara en referens (annars vet den inte "adressen")
			button.objRef = this;
			// Vi skriver över movieclippets originella onRelease funktion mer vår nya. Som sagt, skapa istället en ny klass för movieclippet!..
			button.onRelease = function() {
				// Kalla på buttonClicked i klassen
				this.objRef.buttonClicked(this.id);
			}
		}
		
		// Ladda automatiskt första bilden, som om man skulle ha tryckt på första knappen (dvs id = 0)
		buttonClicked(0);
	}
	
	// EVENTS
	private function buttonClicked(id:Number):Void {
		// Kallar på imageViewer, säger att den skall ladda in bilden, och updatera meta fälten.
		imageViewer.setImage(imageDatabase[id].src, imageDatabase[id].title, imageDatabase[id].description);
	}
}