﻿// importerar Tween klaseen (+ en hel massa easing klasser) för att göra snygga & lätta actionscript animationer
import mx.transitions.Tween;
import mx.transitions.easing.*;

class ImageViewer {
	// VARS
	// Holder, en placeholder där vi laddar in bilden
	private var holder:MovieClip;
	// Vi vill ladda in två bilder utan att skriva över den gamla bilden
	private var holder2:MovieClip;
	// Vi måste ha en variable som håller koll på vilken holder som används just nu
	private var currentHolder:MovieClip;
	// Kommer att bli den stora lådan som fungerar som progressbar
	private var progressBar:MovieClip;
	// Kommer att bli lådan nere som innehåller titel och beskrivning
	private var metaBox:MovieClip;
	// En instance av MovieClipLoader klassen används för att behändigt ladda in klasser. F1, my friend.
	private var loader:MovieClipLoader;
	// Vi sparar referensen till tweenet vi kommer att skapa, så att vi inte alltid behöver skapa nya
	private var progressBarTween:Tween;
	
	// CONSTRUCTOR
	// Skickar in referens till något "fysiskt" som vi kan placera grejer på.
	function ImageViewer(hostMovieClip:MovieClip) {
		
		// Vi skapar ett tomt movieclip för att ladda in bilder i
		holder = hostMovieClip.createEmptyMovieClip("imageHolder", hostMovieClip.getNextHighestDepth());
		
		// Vi skapar en till, för andra bilden ..
		holder2 = hostMovieClip.createEmptyMovieClip("imageHolder2", hostMovieClip.getNextHighestDepth());
		
		// Skapar ett tomt movieclip där vi kan rita en snygg låda som blir en preloader :)
		progressBar = hostMovieClip.createEmptyMovieClip("progressbar", hostMovieClip.getNextHighestDepth());
		
		// Vi "attachar" imageMeta clippet från libaryn (linkage name  "imageMeta") in i hostMovieClip
		metaBox = hostMovieClip.attachMovie("imageMeta", "metaBox", hostMovieClip.getNextHighestDepth());
		
		// Vi placerar metaBoxen i bottnet av skärmen
		metaBox._y = Stage.height - metaBox._height;
		
		// Vi kallar på en funktion som vi skapat som kommer att rita en stor låda som får fungera som progressbar
		drawPreloader();
		
		// Vi placerar progressbaren & bilderna på rätt ställe
		holder._y = holder2._y = progressBar._y = 150;
		
		// Skapar MovieClipLoadern
		loader = new MovieClipLoader();
		
		// Vi måste "lyssna" på loadern, så att vi vet då bilden håller på att laddas, har laddats färdigt mm. Kolla F1 för mer (really? hehe..)
		loader.addListener(this);
	}
	
	// PRIVATE
	private function drawPreloader():Void {
		// Ritar en låda.. Kolla manualen för närmare info
		progressBar.beginFill(0xffffff, 100);
		progressBar.lineTo(600, 0);
		progressBar.lineTo(600, 388);
		progressBar.lineTo(0, 388);
		progressBar.endFill();
		
		// Lådan skall vara osynlig från början
		progressBar._xscale = 0;
	}
	
	// PUBLIC
	// En public funktion som vi kan använda för att ladda in bilder här
	public function setImage(imageUrl:String, title:String, description:String):Void {
		// Vi kollar vilken holder som nu är aktiv och byter ut den vid behov..
		if (currentHolder == holder) {
			currentHolder = holder2;
		} else {
			currentHolder = holder;
		}
		// Vi måste även byta "depth" på holders, så att bilden inte hamnar under den andra
		holder.swapDepths(holder2);
		
		// Delegerar det smutsiga arbetet till MovieClipLoader klassen, really nice ..
		loader.loadClip("images/" + imageUrl, currentHolder);
		
		// progress baren skall vara 0% i bredd, inget har ju laddats ännu!
		progressBar._xscale = 0;
		// ..men den skall vara full synlig, så att vi ser den då 1% eller mer har laddats..
		progressBar._alpha = 100;
		
		// Vi fick in texter, så vi borde kanske använda dem?
		// Alright, vi lägger dem i metaBoxen, som har text holders färdigt
		metaBox.title.text = title;
		metaBox.description.text = description;
	}
	
	// EVENTS
	private function onLoadProgress(target:MovieClip, loaded:Number, total:Number):Void {
		// Vi räknar ut procenten och lägger progressBar procentuella bredden till det resultat vi fått
		// T.ex bild 52kb och 26kb är laddat -> 26/52 = 0.5 * 100 = 50% (oh, complex math!)
		progressBar._xscale = loaded/total*100;
	}
	
	private function onLoadInit(target:MovieClip):Void {
		// Körs då bilden har laddat klart. Vi skapar en tween som fadear ner progressbaren till 0% synlig, coolt!
		progressBarTween = new Tween(progressBar, "_alpha", Strong.easeInOut, 100, 0, 0.5, true);
	}
}