﻿// Extends = ta in all funktionalitet från XML klassen. Kolla manualen på vad XML klassen kan göra.
class XmlLoader extends XML {
	// VARS
	private var _galleryRef:Gallery;
	
	// CONSTRUCTOR
	function XmlLoader(galleryReference:Gallery) {
		// Vi lägger på en inställning som inte tar med sk. whitespace från xml filen.
		// Detta är en variabel som finns i XML klassen (kolla manualen!)
		ignoreWhite = true;
		
		// Vi sparar referensen till galleriet i en variable, så att vi kan skicka info tillbaka då XML har laddats mm
		_galleryRef = galleryReference;
	}
	
	// PRIVATE
	
	// PUBLIC
	
	// EVENTS
	// Gallery klassen säger att denna klass skall ladda in XML med load. Denna funktion är inbyggd i XML klassen,
	// som XmlLoader får all funktionalitet ifrån. Detta gäller då även load() funktionen, som körs från Gallery
	// Då XML är laddat, körs onLoad automatiskt, pga XML klassen, kolla Events i manualen. F1 is your friend!
	private function onLoad(success:Boolean):Void {
		// Försök parsea endast om xml laddandet lyckades
		if (success) {
			// Vi måste först skapa en array (databas) för att kunna lägga in variabler.
			// En Array är som en kö där alla variabler är i .. kö (0, 1, 2, 3 osv). Kolla manualen.
			var copyArray:Array = new Array();
			
			// Vi loopar igenom alla grejer som finns i copy noden i xml'n
			for (var i:Number = 0; i < this.firstChild.childNodes[0].childNodes.length; i++) {
				
				// .. Och lägger dem in i databasen
				copyArray.push(this.firstChild.childNodes[0].childNodes[i].attributes.title);
			}
			
			// Skapar igen en array, men för bilder
			var imageArray:Array = new Array();
			
			// Loopar igenom images noden
			for (var i:Number = 0; i < this.firstChild.childNodes[1].childNodes.length; i++) {
				
				// Eftersom en bild kan innehålla src (source, länk), titel och beskrivning, måste vi skapa ett objekt som lagrar dessa.
				var pic:Object = new Object();
				
				// Skriver in värden i objektet
				pic.src = this.firstChild.childNodes[1].childNodes[i].attributes.src;
				pic.title = this.firstChild.childNodes[1].childNodes[i].attributes.title;
				pic.description = this.firstChild.childNodes[1].childNodes[i].attributes.description;
				
				// .. Och lägger objektet i databasen
				imageArray.push(pic);
			}
			
			// Så, databaserna är klara, vi kan skicka dem tillbaka till Gallery klassen
			_galleryRef.initialize(copyArray, imageArray);
		}
	}
}